=== src/hugin_cpfind/CMakeLists.txt ===
include_directories(.)

add_subdirectory(localfeatures)
add_subdirectory(cpfind)
