=== debian/changelog ===
hugin (2025.0~beta1+dfsg-1) experimental; urgency=medium

  * New upstream version.
  * Update build-dependency list.
  * Run wrap-and-sort -ast.
  * Ship newly availble hugin_toolbox binary.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 05 Oct 2025 15:44:10 +0200
