## hugin 2025.0~rc1%2Bdfsg

=== debian/tests/control ===
Tests:
 simple.pano.test,
Depends:
 hugin,
Restrictions:
 allow-stderr,
