## hugin 2025.0~rc1+dfsg

=== platforms/linux/CMakeLists.txt ===
ADD_SUBDIRECTORY(appdata)
ADD_SUBDIRECTORY(icons)
