=== debian/changelog ===
hugin (2025.0~rc1+dfsg-1) experimental; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 15 Nov 2025 15:49:18 +0100
