## hugin 2025.0.0+dfsg

=== platforms/linux/appdata/CMakeLists.txt ===
IF (UNIX)
# install appdata files
  INSTALL(FILES calibrate_lens_gui.appdata.xml hugin.appdata.xml PTBatcherGUI.appdata.xml hugin_toolbox.appdata.xml DESTINATION ${DATADIR}/metainfo)
ENDIF (UNIX)
