=== debian/changelog ===
hugin (2025.0.0+dfsg-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 20 Nov 2025 18:53:12 -0800

hugin (2025.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Wed, 19 Nov 2025 11:18:46 +0100
