=== debian/control ===
--- 
+++ 
@@ -1,36 +1,32 @@
 Source: hugin
 Section: graphics
 Priority: optional
-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
-Uploaders:
- Andreas Metzler <ametzler@debian.org>,
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Uploaders: Andreas Metzler <ametzler@debian.org>
 # hugin can use Boost::Signal or in Boost >= 1.54 Boost::Signal2 which is
 # shipped in libboost-dev.
-Build-Depends:
- debhelper-compat (= 13),
- dh-python,
- cmake (>= 3.15),
- libepoxy-dev,
- libexiv2-dev (>= 0.12),
- libfftw3-dev,
- libflann-dev,
- liblcms2-dev,
- libopenexr-dev,
- libpano13-dev (>= 2.9.19~beta1),
- libsqlite3-dev,
- libtiff-dev,
- libvigraimpex-dev (>=1.9),
- libwxgtk3.2-dev,
- libx11-dev,
- pkgconf,
- python3-dev,
- python3-setuptools,
- swig (>= 2.0.4),
- zlib1g-dev,
-Build-Conflicts:
- wx2.6-headers,
- wx2.8-headers,
- wx3.0-headers,
+Build-Depends: debhelper-compat (= 13),
+               dh-python,
+               cmake (>= 3.15),
+               libepoxy-dev,
+               libexiv2-dev (>= 0.12),
+               libfftw3-dev,
+               libflann-dev,
+               liblcms2-dev,
+               libopenexr-dev,
+               libpano13-dev (>= 2.9.19~beta1),
+               libsqlite3-dev,
+               libtiff-dev,
+               libvigraimpex-dev (>=1.9),
+               libwxgtk3.2-dev,
+               libx11-dev,
+               pkgconf,
+               python3-dev,
+               python3-setuptools,
+               swig (>= 2.0.4),
+               zlib1g-dev
+Build-Conflicts: wx2.6-headers, wx2.8-headers, wx3.0-headers
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: http://hugin.sourceforge.net/
@@ -39,22 +35,18 @@
 
 Package: hugin
 Architecture: any
-Depends:
- enblend (>= 3.2),
- enfuse,
- hugin-tools (= ${binary:Version}),
- libimage-exiftool-perl,
- make,
- ${misc:Depends},
- ${shlibs:Depends},
-Breaks:
- hugin-bin (<< 0.7.0~svn),
-Replaces:
- hugin-bin (<< 0.7.0~svn),
- hugin-data (<< 0.7.0~svn),
- hugin-tools (<< 0.7.0~svn),
-Suggests:
- dcraw | rawtherapee | darktable,
+Depends: enblend (>= 3.2),
+         enfuse,
+         hugin-tools (= ${binary:Version}),
+         libimage-exiftool-perl,
+         make,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Breaks: hugin-bin (<< 0.7.0~svn)
+Replaces: hugin-bin (<< 0.7.0~svn),
+          hugin-data (<< 0.7.0~svn),
+          hugin-tools (<< 0.7.0~svn)
+Suggests: dcraw | rawtherapee | darktable
 Description: panorama photo stitcher - GUI tools
  Hugin is a panorama photo stitching program. Essentially, Hugin is a
  GUI frontend for Panorama Tools. Stitching is accomplished by using
@@ -73,20 +65,14 @@
 
 Package: hugin-tools
 Architecture: any
-Depends:
- hugin-data (= ${source:Version}),
- ${misc:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Breaks:
- hugin-bin (<< 0.7.0~svn),
- ${python3:Breaks},
-Replaces:
- hugin-bin (<< 0.7.0~svn),
-Recommends:
- libpano13-bin,
-Provides:
- python-hsi,
+Depends: hugin-data (= ${source:Version}),
+         ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends}
+Breaks: hugin-bin (<< 0.7.0~svn), ${python3:Breaks}
+Replaces: hugin-bin (<< 0.7.0~svn)
+Recommends: libpano13-bin
+Provides: python-hsi
 Description: panorama photo stitcher - commandline tools
  Hugin is a panorama photo stitching program.
  .
@@ -122,15 +108,10 @@
 
 Package: hugin-data
 Architecture: all
-Depends:
- ${misc:Depends},
- ${python3:Depends},
- ${shlibs:Depends},
-Breaks:
- ${python3:Breaks},
+Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Breaks: ${python3:Breaks}
 # imports of included plugins
-Suggests:
- python-wxgtk4.0,
+Suggests: python-wxgtk4.0
 Description: panorama photo stitcher - common data files
  Hugin is a panorama photo stitching program.
  .
